class BrakemanTasks < Thor
  include Rails.application.config.dradis.thor_helper_module

  namespace "dradis:plugins:brakeman"

  desc      "upload FILE", "upload Brakeman results in JSON format"
  long_desc "This plugin expect a JSON file generated by Brakeman using: -f "\
            "jason -o results.json"
  def upload(file_path)
    require 'config/environment'

    unless File.exists?(file_path)
      $stderr.puts "** the file [#{file_path}] does not exist"
      exit(-1)
    end

    detect_and_set_project_scope

    importer = Dradis::Plugins::Brakeman::Importer.new(task_options)
    importer.import(file: file_path)
  end

end
